#
# This should be done at initial booting after installation.
#

export LANG=C
export LC_ALL=C

if [ -r /tmp/SeTT_PX ]; then
  ROOT="`cat /tmp/SeTT_PX`"
fi

APACI_DIR=$ROOT/opt/apache_mod_ssl-2.8.15-1.3.28

if [ -d $ROOT/opt/apache ] ; then
  mv $ROOT/opt/apache $ROOT/opt/apache.bak
fi
ln -sf $APACI_DIR $ROOT/opt/apache

if [ -f $ROOT/etc/rc.d/rc.httpd ] ; then
  mv $ROOT/etc/rc.d/rc.httpd $ROOT/etc/rc.d/rc.httpd.org
fi
( cd $ROOT/etc/rc.d/; ln -sf rc.httpsd rc.httpd )
( cd $ROOT/var/log/; ln -sf /opt/apache/logs apache )

if [ -x $ROOT/usr/libexec/namazu.cgi ] ; then
  cp -p $ROOT/usr/libexec/namazu.cgi  $ROOT/opt/apache/cgi-bin/
fi
if [ -f $ROOT/usr/share/namazu/etc/namazu.png ] ; then
  cp -p $ROOT/usr/share/namazu/etc/namazu.png $ROOT/opt/apache/htdocs
fi

/usr/sbin/groupadd apache
/usr/sbin/useradd -g apache wadm
/usr/sbin/useradd -g apache www
chown -R root.apache $APACI_DIR
chown -R wadm $APACI_DIR/htdocs
chmod -R u+w $APACI_DIR/htdocs
chmod -R go+rX $APACI_DIR/{htdocs,cgi-bin,icons,bin,include}
chown -R www $APACI_DIR/proxy


cd $ROOT/
# set access control file(open for your network)
NNAME=`hostname -f`

if [ "$NNAME" != "" ] ; then
	sed -e "s/LOCALHOST/$NNAME/" \
	$APACI_DIR/conf/httpd.conf.template \
	> $APACI_DIR/conf/httpd.conf

	mkdir -p $APACI_DIR/htdocs/new
	(cd $APACI_DIR/htdocs/;
	 for f in index.html* ;
		do sed -e "s/domain/$NNAME/" $f > new/$f ;
	 done;
	 mv new/index.html* .;
	 rmdir new;
	)
fi

( cd $APACI_DIR/conf/; echo "#ServerTokens	Prod" >> httpd.conf )
#( cd $APACI_DIR/bin/; \
#  if [ ! -f /usr/local/bin/perl ] ; then \
#    mv apxs apxs.org; \
#    sed -e "s%/usr/local/bin/perl%/usr/bin/perl%" apxs.org > apxs; \
#    chmod +x apxs; \
#    mv dbmmanage dbmmanage.org; \
#    sed -e "s%/usr/local/bin/perl%/usr/bin/perl%" dbmmanage.org > dbmmanage; \
#    chmod +x dbmmanage; \
#  fi; \
#)

cd $ROOT/


#
# ( DONOT CHANGE THE NEXT ONE LINE )
# Add MOD_SSL Entry to Apache document index.
#
if ! fgrep "MOD_SSL-2.8.15" $ROOT/opt/apache/htdocs/contents.list 1> /dev/null 2>&1; then
  cat >> $ROOT/opt/apache/htdocs/contents.list <<EOL

    <P ALIGN="CENTER">
    MOD_SSL-2.8.15
    (
      <A
	HREF="http://www.modssl.org/"
      > http://www.modssl.org/ </A>
    )
     The Apache Interface to OpenSSL
    <BR>
    OpenSSL-0.9.7
    (
      <A
	HREF="http://www.openssl.org/"
      > http://www.openssl.org/ </A>
    )
     The Open Source Toolkit for SSL/TLS
    <BR>
    MM-1.3
    (
      <A
	HREF="http://www.ossp.org/pkg/lib/mm/"
      > http://www.ossp.org/pkg/lib/mm/ </A>
    )
     Shared Memory Allocation Library
    <BR>
    </P>

EOL
fi

# Create new RSA key for SSL.
if [ "$NNAME" != "" ] ; then
        sed -e "s/LOCALHOST/$NNAME/" \
        $APACI_DIR/bin/mkrsakey.sh.template \
        > $APACI_DIR/bin/mkrsakey.sh
        chmod +x $APACI_DIR/bin/mkrsakey.sh
fi
sh $APACI_DIR/bin/mkrsakey.sh

if [ -f /tmp/add_apache_test.sh ] ; then
    sh /tmp/add_apache_test.sh
    rm -f /tmp/add_apache_test.sh
fi

cd $ROOT/

if [ "$ROOT" = "" ]; then
  /opt/apache/bin/apachectl startssl
fi
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; rm -rf 0cf14d7d.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; ln -sf snakeoil-ca-dsa.crt 0cf14d7d.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; rm -rf e52d41d0.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; ln -sf snakeoil-ca-rsa.crt e52d41d0.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; rm -rf 5d8360e1.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; ln -sf snakeoil-dsa.crt 5d8360e1.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; rm -rf 82ab5372.0 )
( cd opt/apache_mod_ssl-2.8.15-1.3.28/conf/ssl.crt ; ln -sf snakeoil-rsa.crt 82ab5372.0 )
